#version 400

uniform sampler2D tex1;
uniform sampler2D tex2bw;
uniform float distanceRatio;

in vec2 vuv;

out vec4 outCol;

const float near = 0.15;
const float far = 0.01;

void main()
{
	vec4 lookupT1 = texture(tex1,vuv);
	vec4 blendTexColor = texture(tex2bw,vuv);

	float blending = 1.0f - max(blendTexColor.r,blendTexColor.b) + mix(near, far, min(distanceRatio,1.0f));
	if(blending < 1)
	{
		outCol = lookupT1 * (1-blending) + min(blendTexColor*1000,1.0f) * blending;
		outCol.a = 1.0f;
	}
	else
	{
		outCol = lookupT1;
		outCol.a = 1.0f;
	}
	if(lookupT1 == vec4(0.0f,0.0f,0.0f,0.0f))
	{
		outCol = vec4(0.0f,1.0f,0.0f,1.0f);
	}
}