#version 400 core

uniform mat4 mvpMatrix;
uniform mat4 SMMatrix;

layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;

in vec3 teVertex[3];
in vec2 teUV[3];
//in vec4 teColor[3];
out vec2 gUV;
//out vec4 gColor1;
out vec3 gVertex;
out vec4 gSMVertex;
smooth out vec3 gNormal;
	 
void main()
{
	vec3 v1 = teVertex[2] - teVertex[0];
	vec3 v2 = teVertex[1] - teVertex[0];
	vec3 faceNormal = normalize(cross(v1, v2));
	for(int i=0; i<3; ++i)
	{
		gUV = teUV[i];
		//gColor1 = teColor[i];
		gVertex = teVertex[i];
		gNormal = faceNormal;
		
		vec4 vertexPos = gl_in[i].gl_Position;
		
		gSMVertex = SMMatrix * vertexPos;
		gl_Position = mvpMatrix * vertexPos;

		EmitVertex();
	}
	
	EndPrimitive();
}