#version 400 core

uniform sampler2D displacementMap;
uniform bool hasDisplacement;

layout(triangles, equal_spacing, cw) in;
in vec3 tcVertex[];
in vec2 tcUV[];

out vec3 teVertex;
out vec2 teUV;

void main()
{
	vec3 p0 = gl_TessCoord.x * tcVertex[0];
	vec3 p1 = gl_TessCoord.y * tcVertex[1];
	vec3 p2 = gl_TessCoord.z * tcVertex[2];
	teVertex = p0 + p1 + p2;
	vec2 u0 = gl_TessCoord.x * tcUV[0];
	vec2 u1 = gl_TessCoord.y * tcUV[1];
	vec2 u2 = gl_TessCoord.z * tcUV[2];
	teUV = u0 + u1 + u2;

	if(hasDisplacement)
	{
		float displacement = length(texture(displacementMap, teUV).xyz) / 6.0f;
		teVertex.y += displacement;
	}

	gl_Position = vec4(teVertex, 1.0f);
}
