#version 400 core

layout(vertices = 3) out;
in vec3 vPosition[];
in vec3 vNormal[];
in vec2 vUV[];
out vec3 tcPosition[];
out vec3 tcNormal[];
out vec2 tcUV[];

uniform vec3 viewPoint;
uniform mat4 modelMatrix;
uniform bool doTesselation;

#define ID gl_InvocationID; //Funktioniert nicht

void main()
{
	tcPosition[gl_InvocationID] = vPosition[gl_InvocationID];
	tcNormal[gl_InvocationID] = vNormal[gl_InvocationID];
	tcUV[gl_InvocationID] = vUV[gl_InvocationID];
	if(gl_InvocationID == 0)
	{
		float tessLevel;
		if(doTesselation)
			tessLevel = min(max(4.0f - length(viewPoint - vec3(modelMatrix * vec4(vPosition[gl_InvocationID],1.0f))) / 2.0f, 0.5f), 4.0f);
		else
			tessLevel = 1.0f;
		gl_TessLevelInner[0] = tessLevel;
		gl_TessLevelOuter[0] = tessLevel;
		gl_TessLevelOuter[1] = tessLevel;
		gl_TessLevelOuter[2] = tessLevel;
	}
}