#version 330 core
// core

uniform sampler2D textMap;
uniform vec4 textColour;
uniform vec4 outlineColour;
uniform vec3 glowColour;
uniform vec2 glowOffset;

in vec2 vTex;
out vec4 finalColour;

void main()
{
	vec4 baseColour = textColour;
	baseColour.a = texture2D(textMap,vTex).a;
	float distanceFactor = baseColour.a;
	
	float width = fwidth(vTex.x) * 20.0; // 25 is an arbitrary scale factor to get an appropriate width for antialiasing
	baseColour.a = smoothstep(0.5-width, 0.5+width, baseColour.a);
	
/*	// Outline constants
	const float OUTLINE_MIN_0 = 0.4;
	float OUTLINE_MIN_1 = OUTLINE_MIN_0 + width * 2;
	const float OUTLINE_MAX_0 = 0.5;
	float OUTLINE_MAX_1 = OUTLINE_MAX_0 + width * 2;
	
	// Outline calculation
	if (distanceFactor > OUTLINE_MIN_0 && distanceFactor < OUTLINE_MAX_1)
	{
		float outlineAlpha;
		if (distanceFactor < OUTLINE_MIN_1)
			outlineAlpha = smoothstep(OUTLINE_MIN_0, OUTLINE_MIN_1, distanceFactor);
		else
			outlineAlpha = smoothstep(OUTLINE_MAX_1, OUTLINE_MAX_0, distanceFactor);
			
		baseColour = mix(baseColour, outlineColour, outlineAlpha);
	}*/

/*
	// Shadow / glow calculation
	
	vec2 myOffset=glowOffset-vec2(0.001,0.001);
	
	float glowDistance = texture2D(textMap, vTex + myOffset).a;
	float glowFactor = smoothstep(0.3, 0.5, glowDistance);
	
	baseColour = mix(vec4(glowColour, glowFactor), baseColour, baseColour.a);
*/	
	finalColour = baseColour;
}